"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var EventEmitter = require("events");
var VEvent = (function () {
    function VEvent() {
        var _this = this;
        VEvent.emitter.on(VEvent.VIG_EVENT, function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4, this._onEvent.apply(this, args[0])];
                        case 1:
                            _a.sent();
                            return [2];
                    }
                });
            });
        });
    }
    VEvent.getInstance = function () {
        if (!VEvent.instance) {
            VEvent.instance = new VEvent();
        }
        return VEvent.instance;
    };
    VEvent.prototype.add = function (events, isOnce) {
        if (isOnce === void 0) { isOnce = true; }
        var once = isOnce ? "once" : "on";
        if (!events) {
            return;
        }
        if (!events.names) {
            return;
        }
        if (!events.handlers) {
            return;
        }
        for (var _i = 0, _a = events.names; _i < _a.length; _i++) {
            var name = _a[_i];
            var handler = events.handlers[name];
            if (handler) {
                if (isOnce) {
                    this._on(name, handler, VEvent.onceListeners);
                }
                else {
                    this._on(name, handler, VEvent.listeners);
                }
            }
        }
    };
    VEvent.prototype.send = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        VEvent.emitter.emit(VEvent.VIG_EVENT, args);
    };
    VEvent.prototype.on = function (event, handler) {
        this._on(event, handler, VEvent.listeners);
    };
    VEvent.prototype.once = function (event, handler) {
        this._on(event, handler, VEvent.onceListeners);
    };
    VEvent.prototype._on = function (event, handler, listeners) {
        if (!handler) {
            return;
        }
        var handlers = listeners[event];
        if (!handlers) {
            handlers = [];
        }
        if (handlers.indexOf(handler) !== -1) {
            return;
        }
        if (handler instanceof Function) {
            handlers.push(handler);
            listeners[event] = handlers;
        }
    };
    VEvent.prototype._processEvent = function (handlers, params) {
        return __awaiter(this, void 0, void 0, function () {
            var _i, handlers_1, handler;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(handlers instanceof Array)) return [3, 4];
                        _i = 0, handlers_1 = handlers;
                        _a.label = 1;
                    case 1:
                        if (!(_i < handlers_1.length)) return [3, 4];
                        handler = handlers_1[_i];
                        return [4, handler.apply(handler, params)];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        _i++;
                        return [3, 1];
                    case 4: return [2];
                }
            });
        });
    };
    VEvent.prototype._onEvent = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return __awaiter(this, void 0, void 0, function () {
            var event, params, handlers, onceHandlers;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        event = args[0];
                        params = args.splice(1);
                        handlers = VEvent.listeners[event];
                        onceHandlers = VEvent.onceListeners[event];
                        VEvent.onceListeners[event] = null;
                        return [4, this._processEvent(handlers, params)];
                    case 1:
                        _a.sent();
                        return [4, this._processEvent(onceHandlers, params)];
                    case 2:
                        _a.sent();
                        return [2];
                }
            });
        });
    };
    VEvent.emitter = new EventEmitter();
    VEvent.listeners = {};
    VEvent.onceListeners = {};
    VEvent.VIG_EVENT = "__vig_event";
    return VEvent;
}());
exports.VEvent = VEvent;
//# sourceMappingURL=VEvent.js.map